"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@babel/core");
function extractEnumValues(enumDecl) {
    const values = [];
    let lastIndex = -1;
    enumDecl.members.forEach(({ initializer }) => {
        if (initializer) {
            if (core_1.types.isNumericLiteral(initializer)) {
                lastIndex = initializer.value;
                values.push(initializer.value);
            }
            else if (core_1.types.isStringLiteral(initializer)) {
                values.push(initializer.value);
            }
            else {
                // Skip
            }
        }
        else {
            lastIndex += 1;
            values.push(lastIndex);
        }
    });
    return values;
}
exports.default = extractEnumValues;
